package java.security;

public abstract class KeyPairGenerator {
   private String algorithm;

   protected KeyPairGenerator(String var1) {
      this.algorithm = var1;
   }

   public String getAlgorithm() {
      return this.algorithm;
   }

   public static KeyPairGenerator getInstance(String var0) throws NoSuchAlgorithmException {
      try {
         return (KeyPairGenerator)Security.getImpl(var0, "KeyPairGenerator", (String)null);
      } catch (NoSuchProviderException var1) {
         throw new InternalError("please send a bug report via " + System.getProperty("java.vendor.url.bug"));
      }
   }

   public static KeyPairGenerator getInstance(String var0, String var1) throws NoSuchAlgorithmException, NoSuchProviderException {
      return (KeyPairGenerator)Security.getImpl(var0, "KeyPairGenerator", var1);
   }

   public abstract void initialize(int var1, SecureRandom var2);

   public void initialize(int var1) {
      this.initialize(var1, new SecureRandom());
   }

   public abstract KeyPair generateKeyPair();
}
