package java.security;

import java.util.Properties;

public abstract class Provider extends Properties {
   private String name;
   private String info;
   private double version;

   protected Provider(String var1, double var2, String var4) {
      this.name = var1;
      this.version = var2;
      this.info = var4;
   }

   Provider(String var1) {
      this(var1, (double)1.0F, "no information available");
   }

   public String getName() {
      return this.name;
   }

   public double getVersion() {
      return this.version;
   }

   public String getInfo() {
      return this.info;
   }

   static Provider loadProvider(String var0) {
      try {
         Class var1 = Class.forName(var0);
         Object var2 = var1.newInstance();
         if (var2 instanceof Provider) {
            return (Provider)var2;
         }
      } catch (Exception var3) {
         debug("error loading provider " + var0, var3);
      }

      return null;
   }

   public String toString() {
      return this.name + " version " + this.version;
   }

   private static void debug(String var0) {
      Security.debug(var0);
   }

   private static void debug(String var0, Throwable var1) {
      Security.debug(var0, var1);
   }
}
